<?php
/*
*
* @package phpBB3
* @version $Id: polls_block.php v1.1.0 2010-09-02 Nekstati $
* @copyright (c) kevin / saint ( www.board3.de/ ), (c) Ice, (c) nickvergessen ( www.flying-bits.org/ ), (c) redbull254 ( www.digitalfotografie-foren.de ), (c) Christian_N ( www.phpbb-projekt.de ), (c) Nekstati (www.phpbbguru.net)
* @based on: phpBB3 Portal by Sevdin Filiz, www.phpbb3portal.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

if (!defined('IN_PHPBB'))
{
   exit;
}

/**
* @ignore
*/

// Poll settings
$poll_config = array(
	'poll_allow_vote'	=> 1,	// Allow voting (0 or 1)
	'poll_forum_id'		=> '',	// Show polls from listed forums, e. g. '3,12,25' ('' = all forums)
	'poll_exclude_id'	=> 0,	// Show polls from all the forums, except listed in the previous line (0 or 1)
	'poll_hide'			=> 0,	// Hide expired polls (0 or 1)
	'poll_limit'		=> 10,	// Number of polls to display (any integer) (0 = don't display poll block)
);

if (!class_exists('bbcode')) include($phpbb_root_path . 'includes/bbcode.' . $phpEx);
$user->add_lang('viewtopic');

$view = request_var('view', '');
$update = request_var('update', false);
$poll_view = request_var('polls', '');
$pollnumber = request_var('pl', 1);

$poll_view_ar = (strpos($poll_view, ',') !== FALSE) ? explode(',', $poll_view) : (($poll_view != '') ? array($poll_view) : array());

add_form_key('posting');

if ($update && $poll_config['poll_allow_vote'])
{
	$up_topic_id = request_var('t', 0);
	$up_forum_id = request_var('f', 0);
	$voted_id = request_var('vote_id', array('' => 0));

	$cur_voted_id = array();
	if ($user->data['is_registered'])
	{
		$sql = 'SELECT poll_option_id
			FROM ' . POLL_VOTES_TABLE . '
			WHERE topic_id = ' . $up_topic_id . '
				AND vote_user_id = ' . $user->data['user_id'];
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$cur_voted_id[] = $row['poll_option_id'];
		}
		$db->sql_freeresult($result);
	}
	else
	{
		// Cookie based guest tracking ... I don't like this but hum ho
		// it's oft requested. This relies on "nice" users who don't feel
		// the need to delete cookies to mess with results.
		if (isset($_COOKIE[$config['cookie_name'] . '_poll_' . $up_topic_id]))
		{
			$cur_voted_id = explode(',', request_var($config['cookie_name'] . '_poll_' . $up_topic_id, 0, false, true));
			$cur_voted_id = array_map('intval', $cur_voted_id);
		}
	}

	$sql = 'SELECT t.poll_length, t.poll_start, t.poll_vote_change, t.topic_status, f.forum_status, t.poll_max_options
			FROM ' . TOPICS_TABLE . ' t, ' . FORUMS_TABLE . " f
			WHERE t.forum_id = f.forum_id AND t.topic_id = " . (int) $up_topic_id . " AND t.forum_id = " . (int) $up_forum_id;
	$result = $db->sql_query_limit($sql, 1);
	$topic_data = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	$s_can_up_vote = (((!sizeof($cur_voted_id) && $auth->acl_get('f_vote', $up_forum_id)) ||
		($auth->acl_get('f_votechg', $up_forum_id) && $topic_data['poll_vote_change'])) &&
		(($topic_data['poll_length'] != 0 && $topic_data['poll_start'] + $topic_data['poll_length'] > time()) || $topic_data['poll_length'] == 0) &&
		$topic_data['topic_status'] != ITEM_LOCKED &&
		$topic_data['forum_status'] != ITEM_LOCKED) ? true : false;

	if($s_can_up_vote)
	{
		if (!sizeof($voted_id) || sizeof($voted_id) > $topic_data['poll_max_options'] || in_array(VOTE_CONVERTED, $cur_voted_id))
		{
			$redirect_url = append_sid("{$phpbb_root_path}index.$phpEx");

			meta_refresh(5, $redirect_url);
			if (!sizeof($voted_id))
			{
				$message = 'NO_VOTE_OPTION';
			}
			else if (sizeof($voted_id) > $topic_data['poll_max_options'])
			{
				$message = 'TOO_MANY_VOTE_OPTIONS';
			}
			else
			{
				$message = 'VOTE_CONVERTED';
			}

			$message = $user->lang[$message] . '<br /><br />' . sprintf($user->lang['RETURN_INDEX'], '<a href="' . $redirect_url . '">', '</a>');
			trigger_error($message);
		}

		foreach ($voted_id as $option)
		{
			if (in_array($option, $cur_voted_id))
			{
				continue;
			}

			$sql = 'UPDATE ' . POLL_OPTIONS_TABLE . '
				SET poll_option_total = poll_option_total + 1
				WHERE poll_option_id = ' . (int) $option . '
					AND topic_id = ' . (int) $up_topic_id;
			$db->sql_query($sql);

			if ($user->data['is_registered'])
			{
				$sql_ary = array(
					'topic_id'			=> (int) $up_topic_id,
					'poll_option_id'	=> (int) $option,
					'vote_user_id'		=> (int) $user->data['user_id'],
					'vote_user_ip'		=> (string) $user->ip,
				);

				$sql = 'INSERT INTO ' . POLL_VOTES_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
				$db->sql_query($sql);
			}
		}

		foreach ($cur_voted_id as $option)
		{
			if (!in_array($option, $voted_id))
			{
				$sql = 'UPDATE ' . POLL_OPTIONS_TABLE . '
					SET poll_option_total = poll_option_total - 1
					WHERE poll_option_id = ' . (int) $option . '
						AND topic_id = ' . (int) $up_topic_id;
				$db->sql_query($sql);

				if ($user->data['is_registered'])
				{
					$sql = 'DELETE FROM ' . POLL_VOTES_TABLE . '
						WHERE topic_id = ' . (int) $up_topic_id . '
							AND poll_option_id = ' . (int) $option . '
							AND vote_user_id = ' . (int) $user->data['user_id'];
					$db->sql_query($sql);
				}
			}
		}

		if ($user->data['user_id'] == ANONYMOUS && !$user->data['is_bot'])
		{
			$user->set_cookie('poll_' . $up_topic_id, implode(',', $voted_id), time() + 31536000);
		}

		$sql = 'UPDATE ' . TOPICS_TABLE . '
			SET poll_last_vote = ' . time() . "
			WHERE topic_id = $up_topic_id";
		//, topic_last_post_time = ' . time() . " -- for bumping topics with new votes, ignore for now
		$db->sql_query($sql);

		$redirect_url = append_sid("{$phpbb_root_path}index.$phpEx");

		meta_refresh(5, $redirect_url);
		trigger_error($user->lang['VOTE_SUBMITTED'] . '<br /><br />' . sprintf($user->lang['RETURN_INDEX'], '<a href="' . $redirect_url . '">', '</a>'));
	}
}

$where = '';
$poll_forums = false;

// Get readable forums
$forum_list = array();

$forum_list = array_unique(array_keys($auth->acl_getf('f_read', true)));

if($poll_config['poll_forum_id'] !== '')
{
	$poll_forums_config  = explode(',' ,$poll_config['poll_forum_id']);
	
	if($poll_config['poll_exclude_id'])
	{
		$forum_list = array_unique(array_diff($forum_list, $poll_forums_config));
	}
	else
	{
		$forum_list = array_unique(array_intersect($poll_forums_config, $forum_list));
	}
}

$where = '';

if(sizeof($forum_list))
{
	$poll_forums = true;
	$where = 'AND ' . $db->sql_in_set('t.forum_id', $forum_list);
}

if ($poll_config['poll_hide'])
{
	$poll_hide = "AND (t.poll_start + t.poll_length > ". time() ." OR t.poll_length = 0)";
} 
else
{
	$poll_hide = '';
}

if ($poll_forums === true)
{

	$sql = 'SELECT t.poll_title, t.poll_start, t.topic_id,  t.topic_first_post_id, t.topic_first_poster_colour, t.topic_first_poster_name, t.topic_poster, t.forum_id, t.poll_length, t.poll_vote_change, t.poll_max_options, t.topic_status, f.forum_status, p.bbcode_bitfield, p.bbcode_uid
			FROM ' . TOPICS_TABLE . ' t, ' . POSTS_TABLE . ' p, ' . FORUMS_TABLE . " f
			WHERE t.forum_id = f.forum_id AND t.topic_approved = 1 AND t.poll_start > 0
			{$where}
			AND t.topic_moved_id = 0
			AND p.post_id = t.topic_first_post_id
			{$poll_hide}
			ORDER BY t.poll_start DESC";
	$limit = $poll_config['poll_limit'] > 0 ? $poll_config['poll_limit'] : 1;
	$result = $db->sql_query_limit($sql, $limit);
	$has_poll = false;
	$numberrows = $db->sql_affectedrows();
	$i = 0;

	if ($result && $poll_config['poll_limit'] > 0)
	{
		$j = 0;

		while($rowdata = $db->sql_fetchrow($result))
		{
			$data[$j] = $rowdata;
			$j++;
		}

		if ($pollnumber > $numberrows)		$i = $numberrows - 1;
		elseif ($pollnumber <= 0)			$i = 0;
		else								$i = $pollnumber - 1;

		$has_poll = true;
		$poll_has_options = false;

		$topic_id = (int) $data[$i]['topic_id'];
		$forum_id = (int) $data[$i]['forum_id'];

		$cur_voted_id = array();
		if($poll_config['poll_allow_vote'])
		{
			if ($user->data['is_registered'])
			{
				$vote_sql = 'SELECT poll_option_id
					FROM ' . POLL_VOTES_TABLE . '
					WHERE topic_id = ' . $topic_id . '
						AND vote_user_id = ' . $user->data['user_id'];
				$vote_result = $db->sql_query($vote_sql);

				while ($row = $db->sql_fetchrow($vote_result))
				{
					$cur_voted_id[] = $row['poll_option_id'];
				}
				$db->sql_freeresult($vote_result);
			}
			else
			{
				// Cookie based guest tracking ... I don't like this but hum ho
				// it's oft requested. This relies on "nice" users who don't feel
				// the need to delete cookies to mess with results.
				if (isset($_COOKIE[$config['cookie_name'] . '_poll_' . $topic_id]))
				{
					$cur_voted_id = explode(',', request_var($config['cookie_name'] . '_poll_' . $topic_id, 0, false, true));
					$cur_voted_id = array_map('intval', $cur_voted_id);
				}
			}

			$s_can_vote = (((!sizeof($cur_voted_id) && $auth->acl_get('f_vote', $forum_id)) ||
				($auth->acl_get('f_votechg', $forum_id) && $data[$i]['poll_vote_change'])) &&
				(($data[$i]['poll_length'] != 0 && $data[$i]['poll_start'] + $data[$i]['poll_length'] > time()) || $data[$i]['poll_length'] == 0) &&
				$data[$i]['topic_status'] != ITEM_LOCKED &&
				$data[$i]['forum_status'] != ITEM_LOCKED) ? true : false;
		}
		else
		{
			$s_can_vote = false;
		}

		$s_display_results = (!$s_can_vote || ($s_can_vote && sizeof($cur_voted_id)) || ($view == 'viewpoll' && in_array($topic_id, $poll_view_ar))) ? true : false;

		$poll_sql = 'SELECT po.poll_option_id, po.poll_option_text, po.poll_option_total
			FROM ' . POLL_OPTIONS_TABLE . " po
			WHERE po.topic_id = {$topic_id}
			ORDER BY po.poll_option_id";

		$poll_result = $db->sql_query($poll_sql);
		$poll_total_votes = 0;
		$poll_data = array();

		if ($poll_result)
		{
			while($polls_data = $db->sql_fetchrow($poll_result))
			{
				$poll_has_options = true;
				$poll_data[] = $polls_data;
				$poll_total_votes += $polls_data['poll_option_total'];
			}
		}
		$db->sql_freeresult($poll_result);

		$make_poll_view = array();

		if(in_array($topic_id, $poll_view_ar) === FALSE)
		{
			$make_poll_view[] = $topic_id;
			$make_poll_view = array_merge($poll_view_ar, $make_poll_view);
		}

		$poll_view_str = urlencode(implode(',', $make_poll_view));
		$poll_url = append_sid("{$phpbb_root_path}viewtopic.$phpEx", "f=$forum_id&amp;t=$topic_id&amp;view=viewpoll#viewpoll");
		$viewtopic_url = append_sid("{$phpbb_root_path}viewtopic.$phpEx", "f=$forum_id&amp;t=$topic_id");
		$poll_end = $data[$i]['poll_length'] + $data[$i]['poll_start'];

		// Parse BBCode title
		if ($data[$i]['bbcode_bitfield'])
		{
			$poll_bbcode = new bbcode();
		}
		else
		{
			$poll_bbcode = false;
		}

		$data[$i]['poll_title'] = censor_text($data[$i]['poll_title']);

		if ($poll_bbcode !== false)
		{
			$poll_bbcode->bbcode_second_pass($data[$i]['poll_title'], $data[$i]['bbcode_uid'], $data[$i]['bbcode_bitfield']);
		}

		$data[$i]['poll_title'] = bbcode_nl2br($data[$i]['poll_title']);
		$data[$i]['poll_title'] = smiley_text($data[$i]['poll_title']);
		unset($poll_bbcode);

		$template->assign_block_vars('poll', array(
			'S_POLL_HAS_OPTIONS'	=> $poll_has_options,
			'POLL_QUESTION'			=> $data[$i]['poll_title'],
			'POLL_AUTHOR'			=> get_username_string('full', $data[$i]['topic_poster'], $data[$i]['topic_first_poster_name'], $data[$i]['topic_first_poster_colour']),
			'POLL_TIME'				=> $user->format_date($data[$i]['poll_start']),
			'U_POLL_TOPIC'			=> append_sid($phpbb_root_path . 'viewtopic.' . $phpEx . '?t=' . $topic_id . '&amp;f=' . $forum_id),
			'POLL_LENGTH'			=> $data[$i]['poll_length'],
			'TOPIC_ID'				=> $topic_id,
			'TOTAL_VOTES'			=> $poll_total_votes,
			'L_MAX_VOTES'			=> ($data[$i]['poll_max_options'] == 1) ? $user->lang['MAX_OPTION_SELECT'] : sprintf($user->lang['MAX_OPTIONS_SELECT'], $data[$i]['poll_max_options']),
			'L_POLL_LENGTH'			=> ($data[$i]['poll_length']) ? sprintf($user->lang[($poll_end > time()) ? 'POLL_RUN_TILL' : 'POLL_ENDED_AT'], $user->format_date($poll_end)) : '',
			'S_CAN_VOTE'			=> $s_can_vote,
			'S_DISPLAY_RESULTS'		=> $s_display_results,
			'S_IS_MULTI_CHOICE'		=> ($data[$i]['poll_max_options'] > 1) ? true : false,
			'S_POLL_ACTION'			=> $viewtopic_url,
			'U_VIEW_RESULTS'		=> $poll_url,
			'U_VIEW_TOPIC'			=> $viewtopic_url,
		));

		foreach($poll_data as $pd)
		{
			$option_pct = ($poll_total_votes > 0) ? $pd['poll_option_total'] / $poll_total_votes : 0;
			$option_pct_txt = sprintf("%.1d%%", round($option_pct * 100));

			// Parse BBCode option text
			if ($data[$i]['bbcode_bitfield'])
			{
				$poll_bbcode = new bbcode();
			}
			else
			{
				$poll_bbcode = false;
			}

			$pd['poll_option_text'] = censor_text($pd['poll_option_text']);

			if ($poll_bbcode !== false)
			{
				$poll_bbcode->bbcode_second_pass($pd['poll_option_text'], $data[$i]['bbcode_uid'], $data[$i]['bbcode_bitfield']);
			}

			$pd['poll_option_text'] = bbcode_nl2br($pd['poll_option_text']);
			$pd['poll_option_text'] = smiley_text($pd['poll_option_text']);
			unset($poll_bbcode);

			$template->assign_block_vars('poll.poll_option', array(
				'POLL_OPTION_ID'		=> $pd['poll_option_id'],
				'POLL_OPTION_CAPTION'	=> $pd['poll_option_text'],
				'POLL_OPTION_RESULT'	=> $pd['poll_option_total'],
				'POLL_OPTION_PERCENT'	=> $option_pct_txt,
				'POLL_OPTION_PCT'		=> round($option_pct * 100),
				'POLL_OPTION_IMG'		=> $user->img('poll_center', $option_pct_txt, round($option_pct * 250)),
				'POLL_OPTION_VOTED'		=> (in_array($pd['poll_option_id'], $cur_voted_id)) ? true : false
			));
		}
	}
	$db->sql_freeresult($result);

	$template->assign_vars(array(
		'S_DISPLAY_POLL'		=> true,
		'S_HAS_POLL'			=> $has_poll,
		'POLL_LEFT_CAP_IMG'		=> $user->img('poll_left'),
		'POLL_RIGHT_CAP_IMG'	=> $user->img('poll_right'),
		'POLL_TITLE'			=> $numberrows == 1 ? $user->lang['POLL'] : $user->lang['POLLS'],
		'POLL_PAGINATION'		=> generate_poll_pagination(append_sid("{$phpbb_root_path}index.$phpEx"), $numberrows, $i + 1, true),
		'POLL_NUMBER'			=> sprintf($user->lang['PAGE_OF'], $i + 1, $numberrows)
	));
}

function generate_poll_pagination($base_url, $total_pages, $on_page, $add_prevnext_text = false)
{
	global $template, $user;

	$pagination_type = 'pl';
	$anker = '#pl';
	$seperator = '<span class="page-sep">' . $user->lang['COMMA_SEPARATOR'] . '</span>';

	if ($total_pages == 1 || !$total_pages)
	{
		return false;
	}

	$url_delim = (strpos($base_url, '?') === false) ? '?' : '&amp;';

	$page_string = ($on_page == 1) ? '<strong>1</strong>' : '<a href="' . $base_url . $anker .'">1</a>';

	if ($total_pages > 5)
	{
		$start_cnt = min(max(1, $on_page - 4), $total_pages - 5);
		$end_cnt = max(min($total_pages, $on_page + 4), 6);

		$page_string .= ($start_cnt > 1) ? ' ... ' : $seperator;

		for ($i = $start_cnt + 1; $i < $end_cnt; $i++)
		{
			$page_string .= ($i == $on_page) ? '<strong>' . $i . '</strong>' : '<a href="' . $base_url . "{$url_delim}" . $pagination_type . '=' . $i . $anker . '">' . $i . '</a>';
			if ($i < $end_cnt - 1)
			{
				$page_string .= $seperator;
			}
		}
		$page_string .= ($end_cnt < $total_pages) ? ' ... ' : $seperator;
	}
	else
	{
		$page_string .= $seperator;

		for ($i = 2; $i < $total_pages; $i++)
		{
			$page_string .= ($i == $on_page) ? '<strong>' . $i . '</strong>' : '<a href="' . $base_url . "{$url_delim}" . $pagination_type . '=' . $i . $anker . '">' . $i . '</a>';
			if ($i < $total_pages)
			{
				$page_string .= $seperator;
			}
		}
	}
	$page_string .= ($on_page == $total_pages) ? '<strong>' . $total_pages . '</strong>' : '<a href="' . $base_url . "{$url_delim}" . $pagination_type . '=' . $total_pages . $anker . '">' . $total_pages . '</a>';

	if ($add_prevnext_text)
	{
		if ($on_page != 1)
		{
			$page_string = '<a href="' . $base_url . "{$url_delim}" . $pagination_type . '=' . ($on_page - 1) . $anker . '">' . $user->lang['PREVIOUS'] . '</a>&nbsp;&nbsp;' . $page_string;
		}

		if ($on_page != $total_pages)
		{
			$page_string .= '&nbsp;&nbsp;<a href="' . $base_url . "{$url_delim}" . $pagination_type . '=' . ($on_page + 1) . $anker . '">' . $user->lang['NEXT'] . '</a>';
		}
	}

	return $page_string;
}

?>